//========================================================================
/**	@file	FjRecogEngine.h
 *	@brief	Inspirium菑FCuAPI
 *
 *  COPYRIGHT FUJITSU LIMITED 2012, All rights reserved.                */
/*========================================================================*/

#ifndef FJRECOGENGINE_H
#define FJRECOGENGINE_H

#ifdef HWRECENGINE_EXPORTS
#define HWRECENGINE_API __declspec(dllexport)
#else
#define HWRECENGINE_API //__declspec(dllimport)
#endif

#include <tchar.h>

#if !defined(_WIN32_WCE)
using namespace std;
#endif

class HWRECENGINE_API FjRecogEngine
{

protected:
	//FjRecogEngine();


private:


public:
	/* 萔̐錾 */
	// G[Ȃ
	static const int INSPHW_NO_ERROR = 0x0000;
	// GW͏Ă܂
	static const int INSPHW_ERROR_ENGINE_UNINITIALIZED = 0x0001;
	// mۂɎs
	static const int INSPHW_ERROR_ENGINE_ALLOC_MEMORY_ERROR = 0x0002;

	// ͂ꂽPXg[N̍W_̐K͈͊Oł
	static const int INSPHW_ERROR_POINTS_NUMBERS = 0x0010;
	// ͂ꂽXg[NK͈͊Oł
	static const int INSPHW_ERROR_STROKES_NUMBERS = 0x0011;
	// FʃCfbNX̒lK͈͊Oł
	static const int INSPHW_ERROR_RECOG_INDEX = 0x0012;
	// ̗pCfbNX̒lK͈͊Oł
	static const int INSPHW_ERROR_ADOPT_INDEX = 0x0013;
	// GWFʂۑĂ܂
	static const int INSPHW_ERROR_ENGINE_NO_RESULT = 0x0014;

	// setFrame()Ŏw肵TCYK͈͊Oł
	static const int INSPHW_ERROR_SETFRAME_OUT_OF_RANGE_VALUE = 0x0020;
	// setParam()typelK͈͊Oł
	static const int INSPHW_ERROR_SETPARAM_OUT_OF_RANGE_TYPE = 0x0021;
	// setParam()valuelK͈͊Oł
	static const int INSPHW_ERROR_SETPARAM_OUT_OF_RANGE_VALUE = 0x0022;

	// packagePathĂ܂
	static const int INSPHW_ERROR_INIT_NO_PATH = 0x0030;
	// packagePathǂݎ܂
	static const int INSPHW_ERROR_INIT_PATHNAME = 0x0031;

	// setResult()ŔFʂ擾ł܂
	static const int INSPHW_ERROR_SETRESULT_NO_RESULT = 0x0040;

	// contextProc()ŕ␳ł܂
	static const int INSPHW_ERROR_CONTEXTPROC = 0x0050;

	// adaptPattern()Ŏ^o^Ɏs܂
	static const int INSPHW_ERROR_ADAPTPATTERN = 0x0060;

	// getAdaptPatternIds()id̎擾ł܂
	static const int INSPHW_ERROR_GETADAPTIDS = 0x0070;

	// getAdaptPatternChar()ŊwKidɑΉ鐳𕶎R[h܂
	static const int INSPHW_ERROR_GETADAPTCHAR = 0x0080;

	// deleteAdaptPattern()ō폜id܂
	static const int INSPHW_ERROR_DELETEADAPT_NO_ID = 0x0090;
	// deleteAdaptPattern()Ŏ^폜Ɏs܂
	static const int INSPHW_ERROR_DELETEADAPT = 0x0091;

	// őޒlK͈͊Oł
	static const int INSPHW_ERROR_MAXCATEGORY_OUT_OF_RANGE = 0x0100;
	// tB^O[Lڂ镪̌`܂iOt@CŔF͈͂ݒ肷ꍇ̂݁j
	static const int INSPHW_ERROR_FILTER_RULE_FORMAT = 0x0101;
	// tB^O[ݒ莞̎ޒlK͈͊Oł
	static const int INSPHW_ERROR_FILTER_CATEGORY_OUT_OF_RANGE = 0x0102;
	// R[hK͈͊Oł
	static const int INSPHW_ERROR_FILTER_ENCODE_OUT_OF_RANGE = 0x00103;
	// ̎ޒlK͈͊Oł
	static const int INSPHW_ERROR_FILTER_SETTING_CATEGORY_OUT_OF_RANGE = 0x0104;
	// ނݒ肷镶̌`܂iOt@CŔF͈͂ݒ肷ꍇ̂݁jB
	static const int INSPHW_ERROR_FILTER_SETTING_RULE_FORMAT = 0x0105; // SEETINGSETTINGɏC

	// setParam()SETPARAMTYPE
	enum SETPARAMTYPE{RESULT_COUNT, ADOPT_COUNT, MAX_LEARNING_CHAR_SHAPE};

	static FjRecogEngine* createFjRecogEngine();
	virtual ~FjRecogEngine();
	/* ֐̐錾 */
	virtual bool initRecogEngine(const char* packagePath) = 0;
	virtual void endRecogEngine() = 0;
	virtual bool setFrame(int width, int height) = 0;
	virtual bool setParam(SETPARAMTYPE type, int value) = 0;
	virtual bool clearSavedCandList() = 0;
	virtual bool addStroke(int x[], int y[], int n) = 0;
	virtual bool hasPoint() = 0;
	virtual bool resetStroke() = 0;
	virtual int setResult(const int index, TCHAR* result) = 0;
	virtual int getCandIndex(int index) = 0;
	virtual bool deleteCand(int index) = 0;
	virtual bool replaceCand(int h_index, int v_index) = 0;
	virtual bool getSavedCandList(TCHAR* result) = 0;

	virtual bool contextProc() = 0;
	virtual int adaptPattern(int p_index, int l_index) = 0;
	virtual bool clearAdaptPatternDic() = 0;
	virtual int getAdaptPatternIds(int* ids) = 0;
	virtual unsigned short getAdaptPatternChar(int id) = 0;
	virtual bool deleteAdaptPattern(int id) = 0;
	
	virtual bool setMaxCategory(int max) = 0;
	virtual bool setCategory(unsigned short begin, unsigned short end, int mode) = 0;
	virtual bool addFilters(int* filters, int len) = 0;
	virtual bool delFilters(int* filters, int len) = 0;
	virtual bool setAllFiltered() = 0;
	virtual bool setNonFiltered() = 0;
	virtual int getLastError() = 0;
	virtual bool setCategoryEnd() = 0;
};

#endif