﻿#pragma once
#include "FjRecogEngine.h"
#include <collection.h>

using namespace Windows::Foundation::Collections;
using namespace Windows::Foundation;

namespace HWRecogRuntimeComponent
{
	public enum class HWRecogErrorCode {
		INSPHW_NO_ERROR = FjRecogEngine::INSPHW_NO_ERROR,
		INSPHW_ERROR_ENGINE_UNINITIALIZED = FjRecogEngine::INSPHW_ERROR_ENGINE_UNINITIALIZED,
		INSPHW_ERROR_ENGINE_ALLOC_MEMORY_ERROR = FjRecogEngine::INSPHW_ERROR_ENGINE_ALLOC_MEMORY_ERROR,
		INSPHW_ERROR_POINTS_NUMBERS = FjRecogEngine::INSPHW_ERROR_POINTS_NUMBERS,
		INSPHW_ERROR_STROKES_NUMBERS = FjRecogEngine::INSPHW_ERROR_STROKES_NUMBERS,
		INSPHW_ERROR_RECOG_INDEX = FjRecogEngine::INSPHW_ERROR_RECOG_INDEX,
		INSPHW_ERROR_ADOPT_INDEX = FjRecogEngine::INSPHW_ERROR_ADOPT_INDEX,
		INSPHW_ERROR_ENGINE_NO_RESULT = FjRecogEngine::INSPHW_ERROR_ENGINE_NO_RESULT,
		INSPHW_ERROR_SETFRAME_OUT_OF_RANGE_VALUE = FjRecogEngine::INSPHW_ERROR_SETFRAME_OUT_OF_RANGE_VALUE,
		INSPHW_ERROR_SETPARAM_OUT_OF_RANGE_TYPE = FjRecogEngine::INSPHW_ERROR_SETPARAM_OUT_OF_RANGE_TYPE,
		INSPHW_ERROR_SETPARAM_OUT_OF_RANGE_VALUE = FjRecogEngine::INSPHW_ERROR_SETPARAM_OUT_OF_RANGE_VALUE,
		INSPHW_ERROR_INIT_NO_PATH = FjRecogEngine::INSPHW_ERROR_INIT_NO_PATH,
		INSPHW_ERROR_INIT_PATHNAME = FjRecogEngine::INSPHW_ERROR_INIT_PATHNAME,
		INSPHW_ERROR_SETRESULT_NO_RESULT = FjRecogEngine::INSPHW_ERROR_SETRESULT_NO_RESULT,
		INSPHW_ERROR_CONTEXTPROC = FjRecogEngine::INSPHW_ERROR_CONTEXTPROC,
		INSPHW_ERROR_ADAPTPATTERN = FjRecogEngine::INSPHW_ERROR_ADAPTPATTERN,
		INSPHW_ERROR_GETADAPTIDS = FjRecogEngine::INSPHW_ERROR_GETADAPTIDS,
		INSPHW_ERROR_GETADAPTCHAR = FjRecogEngine::INSPHW_ERROR_GETADAPTCHAR,
		INSPHW_ERROR_DELETEADAPT_NO_ID = FjRecogEngine::INSPHW_ERROR_DELETEADAPT_NO_ID,
		INSPHW_ERROR_DELETEADAPT = FjRecogEngine::INSPHW_ERROR_DELETEADAPT,
		INSPHW_ERROR_MAXCATEGORY_OUT_OF_RANGE = FjRecogEngine::INSPHW_ERROR_MAXCATEGORY_OUT_OF_RANGE,
		INSPHW_ERROR_FILTER_RULE_FORMAT = FjRecogEngine::INSPHW_ERROR_FILTER_RULE_FORMAT,
		INSPHW_ERROR_FILTER_CATEGORY_OUT_OF_RANGE = FjRecogEngine::INSPHW_ERROR_FILTER_CATEGORY_OUT_OF_RANGE,
		INSPHW_ERROR_FILTER_ENCODE_OUT_OF_RANGE = FjRecogEngine::INSPHW_ERROR_FILTER_ENCODE_OUT_OF_RANGE,
		INSPHW_ERROR_FILTER_SETTING_CATEGORY_OUT_OF_RANGE = FjRecogEngine::INSPHW_ERROR_FILTER_SETTING_CATEGORY_OUT_OF_RANGE,
		INSPHW_ERROR_FILTER_SETTING_RULE_FORMAT = FjRecogEngine::INSPHW_ERROR_FILTER_SETTING_RULE_FORMAT
	};

	public ref class HWRecogPlugin sealed
	{
	public:
		static bool InitRecogEngine(Platform::String^ path);
		static void EndRecogEngine();
		static bool SetParam(int type, const Platform::Array<int>^ value);
		static bool ClearSavedCandList();
		static bool AddStroke(const Platform::Array<Windows::Foundation::Point>^ points);
		static bool HasPoint();
		static void ResetStroke();
		static Platform::String^ SetResult(int index);
		static int  GetCandIndex(int index);
		static bool DeleteCand(int index);
		static bool ReplaceCand(int h_index, int v_index);
		static Platform::String^ GetSavedCandList();
		static bool ContextProc();
		static bool AddFilters(const Platform::Array<int>^ filters);
		static bool SetMaxCategory(int max);
		static bool SetCategory(unsigned short begin, unsigned short end, int mode);
		static bool SetCategoryEnd();
		static bool DelFilters(const Platform::Array<int>^ filters);
		static bool SetNonFiltered();
		static bool SetAllFiltered();
		static int GetLastError();
		static bool ClearAdaptPatternDic();
		static int AdaptPattern(int p_index, int l_index);
		static Platform::Array<int>^ GetAdaptPatternIds();
		static bool DeleteAdaptPattern(int id);
		static wchar_t GetAdaptPatternChar(int id);
	};
}
